

require 'imbir5'
floor = math.floor
getmetatable('').__index = function(s,i) return string.sub(s,i,i) end


READY = 1
GAMEMOVERIGHT = 2
GAMEMOVELEFT = 3
GAMEMOVEDOWN = 4
NEXTSTATE = 'durr'





function Reset(level,score)
	ALIENS = {rows=3, cols=4, w=20, h=6, steps = 10, stepsw = 100, maxx = 770, minx = 30}
	ALIENS.n = ALIENS.rows*ALIENS.cols
	STATE = READY
	SCORE = score or 0
	LEVEL = level or 1
	FPS = LEVEL
	
	X = World()
	
	ship = Imbir{
		position = {x=400,y=500}, 
		rect = {rx = 10, ry = 8}, 
		delta = {x=0,y=0},
		collidable = true,
		pellet = 0,
		parent = {}
		}
	--block = Imbir{position = {x=40,y=300}}
	
	X = X + ship
	
	local spacex,spacey = floor(600/(ALIENS.cols)), floor(200/(ALIENS.rows))
	for j=1,ALIENS.rows do
		for i=1,ALIENS.cols do
			X = X + Imbir{
				position = {x=100 + spacex*(i-1), y = 100 + spacey*(j-1)}, 
				rect = {rx = ALIENS.w/2, ry = ALIENS.h/2}, 
				delta = {x=0,y=0},
				alien = true,
				collidable = true,
				pellet = 0,
				parent = {}
				}
		end
	end

end

Reset()








System{
	_name = 'draw',
	
	'rect',
	'position',
	
	Logic = function(a)
		love.graphics.rectangle('fill',a.position.x-a.rect.rx, a.position.y-a.rect.ry, a.rect.rx*2, a.rect.ry*2)
	end
	}
System{
	_name = 'input',
	
	'input',
	'delta',
	
	Logic = function(a)
		if a.input == 'left' then
			a.delta.x = a.position.x > 100 and -5 or 0
		elseif a.input == 'right' then
			a.delta.x = a.position.x < 700 and 5 or 0
		elseif a.input == 'space' and a.pellet==0 then
			X = X + Imbir{
				position = {x=a.position.x, y=a.position.y-10},
				rect = {rx = 2, ry = 4},
				velocity = {x=0,y=-10},
				delta = {x=0,y=0},
				parent = a,
				collidable = true
				}
			a.pellet = a.pellet+1
		end
		a.input = nil
		
		if STATE == READY then
			STATE = GAMEMOVERIGHT
		end
	end
	}
System{
	_name = 'alienShots',
	
	'alien',
	'position',
	
	Logic = function(a)
		if STATE ~= READY and a.pellet==0 and math.random() < 0.1 then
			X = X + Imbir{
				position = {x=a.position.x, y=a.position.y+10},
				rect = {rx = 2, ry = 4},
				velocity = {x=0,y=4},
				delta = {x=0,y=0},
				parent = a,
				collidable = true
				}
			a.pellet = a.pellet+1
		end
	end
	}
System{
	_name = 'applyVelocity',
	
	'velocity',
	'position',
	
	Logic = function(a)
		a.delta.x,a.delta.y = a.velocity.x,a.velocity.y
	end
	}
System{
	_name = 'checkOOB',
	
	'position',
	
	Logic = function(a)
		if math.abs(a.position.x-400)>400  or  math.abs(a.position.y-300)>300 then
			if a._id == ship._id then
				Reset()
			end
			
			X = X - a
			if a.parent.pellet then
				a.parent.pellet = math.max(0,a.parent.pellet-1)
			end
			
			if a.alien then
				SCORE = SCORE + 100*LEVEL
				ALIENS.n = ALIENS.n-1
				if ALIENS.n == 0 then
					Reset(LEVEL+1,SCORE)
				end
			end
		end
	end
	}
System{
	_name = 'detectCollisions',
	
	'rect',
	'position',
	'collidable',
	
	Logic = function(a)
		local bx,by = floor(a.position.x/ALIENS.w), floor(a.position.y/(ALIENS.h*2))
		if col(bx,by) then
			X = X+Imbir{collision = {a,col(bx,by)}}
			COL(bx,by, nil)
		else
			COL(bx,by, a)
		end
	end
	}
System{
	_name = 'handleCollisions',
	
	'collision',
	
	Logic = function(a)
		local b = a.collision[2]
		a = a.collision[1]
		
		if (a.alien or b.alien) and (a.parent.alien or b.parent.alien) then
			return
		end
		
		a.position.x = -100
		a.position.y = -100
		b.position.x = -100
		b.position.y = -100
	end
	}
System{
	_name = 'applyDelta',
	
	'delta',
	'position',
	
	Logic = function(a)
		a.position.x = a.position.x + a.delta.x
		a.position.y = a.position.y + a.delta.y
		a.delta.x,a.delta.y = 0,0
	end
	}
System{
	_name = 'workOnAliensState',
	
	'position',
	'alien',
	
	Logic = function(a)
		if STATE == GAMEMOVERIGHT then
			if a.position.x > ALIENS.maxx then
				STATE = GAMEMOVEDOWN
				NEXTSTATE = GAMEMOVELEFT
			end
		elseif STATE == GAMEMOVELEFT then
			if a.position.x < ALIENS.minx then
				STATE = GAMEMOVEDOWN
				NEXTSTATE = GAMEMOVERIGHT
			end
		end
	end
	}
System{
	_name = 'deltaAliens',
	
	'delta',
	'position',
	'alien',
	
	Logic = function(a)
		if STATE == GAMEMOVERIGHT then
			a.delta.x = 10
		elseif STATE == GAMEMOVELEFT then
			a.delta.x = -10
		elseif STATE == GAMEMOVEDOWN then
			a.delta.y = 20
		end
	end
	}
	
	
	
	
	
function col(x,y)
	collisions[y] = collisions[y] or {}
	return collisions[y][x]
end
function COL(x,y,v)
	col(x,y)
	collisions[y][x] = v
end
	
time = 0
timeal = 0
function love.update(dt)
	local fps = 1/60
	local fpsal = 1/FPS
	
	timeal = timeal+dt
	while timeal > fpsal do
		timeal = timeal-fpsal
		
		
		if STATE == GAMEMOVEDOWN then
			STATE = NEXTSTATE
			FPS = FPS + 1
		end
		
		X{'workOnAliensState','deltaAliens','alienShots'}
	end
	
	time = time+dt	
	while time > fps do
		time = time-fps
		
		collisions = {}
		X{'input','applyVelocity','detectCollisions','handleCollisions','checkOOB','applyDelta'}
	end
end






function love.draw()
	X{'draw'}	
	love.graphics.print(SCORE, 350,10, 0, 5,5)
end






love.keyboard.setKeyRepeat(0.1,0.1)
function love.keypressed(key)
	if key=='left' then 
		ship.input = 'left'
	elseif key=='right' then 
		ship.input = 'right'
	elseif key==' ' then
		ship.input = 'space'
    elseif key == 'escape' then
        love.event.push('quit') -- Quit the game.
    end 
end

